Subject: Re: [PATCH] test-string-list.c: Fix some sparse warnings

From: Michael Haggerty <[email-masked]>
Date: Thu, 20 Sep 2012 09:13:37 +0200

On 09/19/2012 09:07 PM, Ramsay Jones wrote:
> Michael Haggerty wrote:
>> Is there some documentation about how to run sparse on the git codebase?
>>  I naively tried "make sparse" and ended up with zillions of errors like
>>
>> /usr/include/unistd.h:288:54: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:294:6: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:298:6: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:306:6: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:338:18: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:347:6: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:418:36: error: attribute '__leaf__': unknown attribute
>> /usr/include/unistd.h:423:50: error: attribute '__leaf__': unknown attribute
> 
> Yep, "make sparse" is the correct way to run sparse over git.
> 
> This looks like you are running sparse on a 64-bit system. I have heard that
> it has (or *had*) problems running on 64-bit systems. Unfortunately, I am
> currently confined to 32-bit. (I'm looking at getting a new laptop soon, before
> Windows 8 causes boot-time problems, so I will then have the same problem!)
> 
> How did you obtain/build/install sparse? The current release (v0.4.4) was
> released about Nov 2011 and I think you need a more up to date version.
> i.e. you need to build the latest, directly from the sparse repo.

Yes, I'm running 64-bit Ubuntu 12.04 "precise".  I installed sparse from
the Ubuntu "multiverse" repository.  It is package version
0.4.3+20110419-1 in Ubuntu's notation.

Thanks very much for all the info.  I hadn't heard of sparse before and
thought that using it might help me avoid submitting patches with
problems like the ones you detected.  It does seem promising!  But since
it seems a bit fiddly to get it running, and even then has some
problems, it doesn't sound like the simple pre-submit checklist item
that I had imagined.

Michael

-- 
Michael Haggerty
[email-masked]
http://softwareswirl.blogspot.com/